/*	mdd - multi domed daemon

	by Dobrica Pavlinusic (dpavlin@foi.hr)
*/

#include <sys/types.h>
#include <sys/socket.h>
#include <netinet/in.h>
#include <netdb.h>
#include <stdio.h>
#include "config.h"

int o_syslog = 1;

/*	inetd stuff
*/

int main(int argc, char **argv)
{

struct sockaddr_in s_sin,c_sin;
int len;
char buf[1];
extern char *optarg;
extern int optind;
int o;

len=sizeof(s_sin);
if ( getsockname(0, (struct sockaddr *)&s_sin, &len) < 0 )
	perror("can't get socket name");

/* fill rest of data (on Solaris, anyway) */
len=sizeof(s_sin);
recvfrom(0, (char *)buf, 0, MSG_PEEK,  (struct sockaddr *)&s_sin, &len);

len=sizeof(s_sin);
if ( getpeername(0, (struct sockaddr *)&c_sin, &len) < 0 ) {
	perror("can't get client name");
/*	exit(1);*/
}

/*
len=sizeof(c_sin);
recvfrom(0, (char *)buf, 0, MSG_PEEK,  (struct sockaddr *)&c_sin, &len);
*/

#ifdef DEBUG
printf("s: %s:%d\n\r", inet_ntoa(s_sin.sin_addr), s_sin.sin_port);
printf("c: %s:%d\n\r", inet_ntoa(c_sin.sin_addr), c_sin.sin_port);
#endif

while ((o = getopt(argc, argv, "df:V")) != -1)
	switch(o) {
	case 'd': o_syslog=0;
	case 'V': puts(VERSION); break;
	case 'f':
		parse(optarg, strdup(inet_ntoa(s_sin.sin_addr)), strdup(inet_ntoa(c_sin.sin_addr)));
		break;
	default:
		parse(CONF_FILE, strdup(inet_ntoa(s_sin.sin_addr)), strdup(inet_ntoa(c_sin.sin_addr)));
		break;
	}
}
